---
Name: set-machine-ip-in-joinup
Description: Read and Save the Machine IP
Documentation: /
  Alternative to set-machine-ip-in-sledgehammer.
  Used to read an existing IP address and assign it to the Machine

  This is needed when using the Join-Up process in clouds
  where no DHCP is used and machines are assigned fixed addresses.

  No action when running in a context

  Needed in >v4.3 because IP setting was removed from join-up.sh

Meta:
  type: "config"
  icon: "magnet"
  color: "yellow"
  title: "Community Content"
  copyright: "RackN 2020"
  feature-flags: "sane-exit-codes"
Templates:
  - Name: set-machine-ip
    Meta:
      OS: "linux"
    Contents: |
      #!/usr/bin/env bash
      # set-machine-ip-joinup task for Linux platforms

      {{ if eq (len .Machine.Context) 0 }}

      IP=""
      BOOTDEV="eth0"
      echo "Looking up IP address on $BOOTDEV"
      bootdev_ip4_re='inet ([0-9.]+)/([0-9]+)'
      bootdev_ip6_re='inet6 ([0-9a-fA-F:.]+)/([0-9]+) scope global'
      if [[ $(ip -4 -o addr show dev $BOOTDEV) =~ $bootdev_ip4_re ]]; then
          IP="${BASH_REMATCH[1]}"
      else
          if [[ $(ip -6 -o addr show dev $BOOTDEV) =~ $bootdev_ip6_re ]]; then
              IP="${BASH_REMATCH[1]}"
          fi
      fi

      addr='{{.Machine.Address}}'
      echo "O/S Address determined to be $IP.  Machine.Address = $addr"
      if [[ $IP && $addr == '<nil>' ]] ; then
        echo "Address not set, updating"
        drpcli machines update "$RS_UUID" "{\"Address\":\"$IP\"}" &>/dev/null
      else
        echo "Did not set/reset address: Detected = $IP and Machine.Address = $addr"
      fi

      {{ else }}
      echo "No Action: Do NOT SET IP when in Machine.Context {{.Machine.Context}}"
      {{ end }}

      echo "done"
      exit 0
  - Name: "set-machine-ip-joinup-esxi.sh"
    Meta:
      OS: "esxi"
    Contents: |
      #!/usr/bin/env sh
      # set-machine-ip-joinup task for ESXi platforms

      echo "The 'set-machine-ip-joinup' task does not work on VMware ESXi platforms yet."
      exit 0

  - Name: "set-machine-ip-joinup.ps1"
    Meta:
      OS: "windows"
    Contents: |
      # set-machine-ip-joinup task for Windows platforms

      Write-Host "The 'set-machine-ip-joinup' task does not work on Windows platforms yet."
      exit 0

